using System;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Common;
using System.Data.Entity;
using System.Data.Entity.Core.Common;
using System.Data.SQLite;
using System.Data.SQLite.EF6;
using SQLite.CodeFirst;

namespace TourDataManager {

    [Table("Foo")]
    public class Foo {
        public long Id{ get; set; }

        public string Data{ get; set; }
    }
    
    public class SQLiteConfiguration : DbConfiguration
    {
        public SQLiteConfiguration()
        {
            SetProviderFactory("System.Data.SQLite", SQLiteFactory.Instance);
            SetProviderFactory("System.Data.SQLite.EF6", SQLiteProviderFactory.Instance);
            SetProviderServices("System.Data.SQLite", (DbProviderServices)SQLiteProviderFactory.Instance.GetService(typeof(DbProviderServices)));
        }
    }

    //[DbConfigurationType(typeof(Ef6CodeConfig))]
    public class MyDbContext : DbContext{

        public MyDbContext(DbConnection connection, bool contextOwnsConnection) 
            : base(connection,contextOwnsConnection){
            
                DbConfiguration.SetConfiguration(new SQLiteConfiguration());
                Configuration.ProxyCreationEnabled = true;
                Configuration.LazyLoadingEnabled = true;
        }
  
        protected override void OnModelCreating(DbModelBuilder modelBuilder){

            //modelBuilder.Entity<Foo>();
            var sqliteConnectionInitializer = new SqliteCreateDatabaseIfNotExists<MyDbContext>(modelBuilder);
            Database.SetInitializer(sqliteConnectionInitializer);
        }

        public DbSet<Foo> Foo{ get; set; }
        
        


    }
    
    public class Db {
        public Db(){

            using (var sqLiteConnection = new System.Data.SQLite.SQLiteConnection("data source=mylovelybase.sqlite")){
                using (var db = new MyDbContext(sqLiteConnection,true)){
                    db.Foo.Add(new Foo{Id = new Random().Next(0,1000), Data = "Yolo"});
                    db.SaveChanges();
                    
                    //db.Set<Foo>()
                }
            }

            
        }
    }
}